//
// HelloSoQt.cpp
//
// by Stephan Siemen     Sep. 2002
//
// Dieser Code kann mit 
//    g++ HelloSoQt.cpp -o HelloSoQt -lCoin -lSoQt -I$QTDIR/include
// uebersetzt werden

// Headerdateien von SoQt  
#include <Inventor/Qt/SoQt.h>
#include <Inventor/Qt/viewers/SoQtExaminerViewer.h>
// Headerdateien von Coin 
#include <Inventor/nodes/SoBaseColor.h>
#include <Inventor/nodes/SoText3.h>
#include <Inventor/nodes/SoSeparator.h>
  
int main(int argc, char ** argv)
{
  // Initialisierung der SoQt Bibliothek 
  // Der Rueckgabewert erzeugt ein Qt Fenster
  QWidget *fenster = SoQt::init("test");
  
  // Erstellen eines "scene graphs" 
  SoSeparator *wurzel = new SoSeparator;
  wurzel->ref();

  // Setzen der Farbe - in RGB - hier: gelb
  SoBaseColor *farbe = new SoBaseColor;
   farbe->rgb = SbColor(1, 1, 0); 
  wurzel->addChild(farbe);

  // Erzeugen des Texts
  SoText3 * text3D = new SoText3();
   text3D->string.setValue("Hello SoQt");
  wurzel->addChild(text3D);
  
  // Erzeugen des Betrachters
  SoQtExaminerViewer *b = new SoQtExaminerViewer(fenster);
  b->setSceneGraph(wurzel);
  b->show();
  
  // Start des Fensters 
  SoQt::show(fenster);
  // Loop until exit.
  SoQt::mainLoop();

  // Loeschen des Betrachters 
  // und der Referenz zur Szene
  delete b;
  wurzel->unref();

  return 0;
}
